#include <zephyr/kernel.h>
#include <zephyr/logging/log.h>
#include <zephyr/zbus/zbus.h>

#include "utilities.h"
#include "main-handler.h"
#include "debug-handler.h"
#include "driver-hook.h"
#include "device-parser.h"

#if !defined(CONFIG_SOC_POSIX)
#include "ble-scanner.h"
#include "wifi-controller.h"
#endif


LOG_MODULE_REGISTER(main);

DriverMessage_t defaultDriverMsg;
StateMessage_t defaultStateMsg;
BleData_t defaultBleData;

ZBUS_CHAN_DEFINE(driverRequestChannel,       /* Name */
		 DriverMessage_t,             /* Message type */
		 NULL,                 /* Validator */
		 NULL,                 /* User data */
		 ZBUS_OBSERVERS_EMPTY, /* observers */
		 ZBUS_MSG_INIT(defaultDriverMsg)
);

ZBUS_CHAN_DEFINE(driverResponseChannel,       /* Name */
		 DriverMessage_t,             /* Message type */
		 NULL,                 /* Validator */
		 NULL,                 /* User data */
		 ZBUS_OBSERVERS_EMPTY, /* observers */
		 ZBUS_MSG_INIT(defaultDriverMsg)
);

ZBUS_CHAN_DEFINE(bleScanChannel,       /* Name */
		 BleData_t,             /* Message type */
		 NULL,                 /* Validator */
		 NULL,                 /* User data */
		 ZBUS_OBSERVERS_EMPTY, /* observers */
		 ZBUS_MSG_INIT(defaultBleData)
);

ZBUS_CHAN_DEFINE(stateChannel,       /* Name */
		 StateMessage_t,             /* Message type */
		 NULL,                 /* Validator */
		 NULL,                 /* User data */
		 ZBUS_OBSERVERS_EMPTY, /* observers */
		 ZBUS_MSG_INIT(defaultStateMsg)
);

int main()
{
	DebugHandler debugHanddler;
	MainHandler mainHandler;
	DriverHook driverHook;
	DeviceParser deviceParser;

	while(true) {
		// LOG_INF("Hello World! run app\n");
		k_sleep(K_SECONDS(5));
	}
}