#pragma once

#include <zephyr/kernel.h>
#include <vector>

typedef enum DataType{
    DEBUG_STATE,
    DEBUG_BLE,
    DEBUG_DRIVER
} DataType_e;

typedef struct DebugMessage {
    DataType_e flag;
    std::vector<uint8_t> value;
} DebugMessage_t;

class DebugHandler {
public:
    /** Constructor.
     *
     **/
    DebugHandler();

    /** Destructor.
     *
     **/
    ~DebugHandler();


    void Init();

    int Deinit();

    static void DriverResponseListener(const struct zbus_channel *chan);
    static void StateListener(const struct zbus_channel *chan);
    static void BleListener(const struct zbus_channel *chan);

private:
    static void DebugThread(DebugHandler *context);
    int SendPacket(uint8_t *buf, uint16_t size);
    
        
};