#pragma once

#include <zephyr/kernel.h>

#include "ble-scanner.h"
#include "led-driver.h"
#include "servo-driver.h"
#include "ir-driver.h"

class DriverHook {
public:
    /** Constructor.
     *
     **/
    DriverHook();

    /** Destructor.
     *
     **/
    ~DriverHook();


    void Init();

    int Deinit();

    static void DriverRequestListener(const struct zbus_channel *chan);

    static void IrSensorCallback(uint8_t data);

    static void  BleDataCallback(std::string addr, std::vector<uint8_t> data, int8_t rssi);

private:
#ifndef CONFIG_SOC_POSIX
    BleScanner *bleScanner;
    LedDriver *ledDriver;
    ServoDriver *servoDriver;
    IrDriver *irDriver;
#endif
};