#pragma once

#include <zephyr/kernel.h>
#include <string>

class IrDriver {
public:
    void (*registeredCallback)(uint8_t) = NULL;
    struct k_work work;

    /** Constructor.
     *
     **/
    IrDriver();

    /** Destructor.
     *
     **/
    ~IrDriver();

    bool GetState();

    void RegisterInterrupt(void (*callback)(uint8_t));

private: 

    static void InterruptCallback(const struct device *dev, struct gpio_callback *cb, uint32_t pins);

    static void InterruptHandler(struct k_work *item);
};