#pragma once

#include <zephyr/kernel.h>
#include "utilities.h"

typedef enum DeviceState{
    STANDBY,
    SCANNING,
    USER_1,
    USER_2
} DeviceState_e;

class MainHandler {
public:
    /** Constructor.
     *
     **/
    MainHandler();

    /** Destructor.
     *
     **/
    ~MainHandler();


    void Init();

    int Deinit();

    static void DriverResponseListener(const struct zbus_channel *chan);

private:

    DriverNumb_e requestedResponse;
    DriverMessage_t driverResponse_g;
    uint8_t currentState;

    static void MainThread(MainHandler *context);
    bool DriverRequest(DriverMessage_t *sentMessage, DriverMessage_t *driverResponse, k_timeout_t timeout);
        
};