#pragma once

#include <vector>
#include <string>

typedef enum DriverNumb{
    BLUETOOTH,
    SERVO,
    LED,
    IR_DRIVER
} DriverNumb_e;

typedef enum StateFlag{
    STATE,
    DATA_1,
    DATA_2
} StateFlag_e;

typedef enum ExchangeType{
    REQUEST_GET,
    REQUEST_SET,
    RESPONSE_GET,
    RESPONSE_SET
} ExchangeType_e;

typedef struct DriverMessage {
    DriverNumb_e number;
    ExchangeType_e type;
    std::vector<uint8_t> value;
} DriverMessage_t;

typedef struct StateMessage {
    StateFlag_e flag;
    std::vector<uint8_t> value;
} StateMessage_t;

typedef struct BleData {
    std::string address;
    std::vector<uint8_t> data;
} BleData_t;