#!/bin/bash
set -e

TOOLCHAIN_FILE="tools/toolchain-cmake/gnuarm.cmake"
BUILD_COMPILER="gnuarm"
BUILD_TYPE="Release"
OVERLAY_DIR="$(pwd)/mtp-lpmcu/boards/arm/mtp_lpc55s28/lpc_evk.overlay"

while getopts ":l:o:" option; do
  case $option in
    l) if [[ $OPTARG == "clang" ]]; then TOOLCHAIN_FILE="tools/toolchain-cmake/clang.cmake";BUILD_COMPILER="clang"; fi ;;
    o) OVERLAY_DIR=$OPTARG; echo "set overlay to $OPTARG";;
    *) ;;
  esac
done

OPTIND=1

build_app()
{
  west build -b mtp_lpc55s28 mtp-lpmcu/app --build-dir .build-mtp-lpmcu-lpc55s28-app-only -- -DCMAKE_EXPORT_COMPILE_COMMANDS=ON -DDTC_OVERLAY_FILE=${OVERLAY_DIR}
}

while getopts ":labepn" option; do
  case $option in
    # a) build_app ;;
    # b) build_boot ;;
    # n) build_app_only ;;
    *) build_app;;
  esac
done
